#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		_ntp		ntp
%global		__python	/usr/bin/python3
#-----------------------------------------------------------------------------
Name		:	ntpsec
Version		:	1.2.1
Release		:	14.8.0.0%{?dist}
Summary		:	The NTP daemon and utilities
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	(MIT and BSD and BSD with advertising) and GPLv2
URL		:	https://www.ntpsec.org/
			#https://ftp.ntpsec.org/pub/releases/

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
Patch0		:	%{name}-%{version}-openssl-3.patch

#-----------------------------------------------------------------------------
BuildRequires	:	bison
BuildRequires	:	gcc
BuildRequires	:	gnupg
BuildRequires	:	m4
BuildRequires	:	openssl-devel
BuildRequires	:	waf

Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	wget
Requires	:	make-ca
#-----------------------------------------------------------------------------
%description
NTPsec is a more secure and improved implementation of the Network Time
Protocol derived from the original NTP project.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{_ntp}d
#dir %attr(0744,%{_ntp},%{_ntp}) %{_var}/lib/%{name}
%config (noreplace) %{_sysconfdir}/%{_ntp}.conf
%config (noreplace) %{_sysconfdir}/cron.monthly/%{_ntp}-leap.cron
%config (noreplace) %{_sysconfdir}/logrotate.d/%{_ntp}d
%{_sbindir}/ntpd
%{_bindir}/ntpdig
%{_bindir}/ntpfrob
%{_bindir}/ntpkeygen
%{_bindir}/ntpleapfetch
%{_bindir}/ntplogtemp
%{_bindir}/ntpmon
%{_bindir}/ntpq
%{_bindir}/ntpsnmpd
%{_bindir}/ntpsweep
%{_bindir}/ntptime
%{_bindir}/ntptrace
%{_bindir}/ntpviz
%{_bindir}/ntpwait
%{_libdir}/libntpc.so*
%{python3_sitelib}/%{_ntp}-%{version}.egg-info
%{python3_sitelib}/%{_ntp}/*.py
%{python3_sitelib}/%{_ntp}/__pycache__/*.pyc
%{python3_sitelib}/%{_ntp}/__pycache__/*.pyo
%{_mandir}/man1/*.1.gz
%{_mandir}/man5/*.5.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{_ntp}
  /usr/sbin/useradd 				\
	-r					\
	-c "Network Time Protocol"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{_ntp}				\
	-s /sbin/nologin			\
	-d %{_var}/lib/%{name}			\
	%{_ntp}
  fi

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{_ntp}d stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{_ntp}d
  /usr/sbin/userdel %{_ntp}
  %{__rm} -rf %{_sysconfdir}/ntp.leapseconds
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
/sbin/chkconfig --add %{_ntp}d
%{_sysconfdir}/rc.d/init.d/%{_ntp}d condrestart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q
%patch0 -p1

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}

./waf configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}/			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-debug					\
	--enable-debug-gdb				\
	--disable-doc					\
	--python=%{__python}				\
	--refclock=pps,generic,nmea,trimble,local


#define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%define _smp_mflags -j1

./waf 							\
	%{_smp_mflags}					\
	build

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

./waf							\
	--destdir=%{buildroot}				\
	install

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/
%{__cp} -a 						\
	%{name}-ok_addon/%{_ntp}d			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/
	
%{__cp} -a 						\
	%{name}-ok_addon/%{_ntp}.conf			\
	%{buildroot}%{_sysconfdir}

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} -a 						\
	%{name}-ok_addon/logrotate			\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{_ntp}d


#adding the update-leap cron
%{__mkdir_p} %{buildroot}%{_sysconfdir}/cron.monthly
%{__cp} -a 						\
	%{name}-ok_addon/%{_ntp}-leap.cron		\
	%{buildroot}%{_sysconfdir}/cron.monthly

#-----------------------------------------------------------------------------
%changelog
